/*
 * qmail mrtg from inter7 
 *
 * Copyright (C) 2001 Inter7 Internet Technologies, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include "virusscanner.h"
#include "/usr/local/mysql/include/mysql.h"

/************************/
#define MYSQLHOST "localhost"
#define MYSQLUSER "user"
#define MYSQLPASS "pass"
#define MYSQLDB   "virus"
/************************/

#define MAX_BUFF 1000
char TmpBuf[MAX_BUFF];

double bytes;
int max_files;

time_t end_time;
time_t start_time;
unsigned long get_tai( char *);
void get_options(int argc, char **argv);
char TheDir[MAX_BUFF];
char TheFile[MAX_BUFF];
void process_file( char *file_name); 
int get_size(char *dir);
int count_files(char *diri);

char TheType;

int main( int argc, char **argv)
{ 
 DIR *mydir;
 struct dirent *mydirent;
 unsigned long secs;

    if ( argc != 2 ) { 
        printf("usage: dir\n");
        printf("where dir is a directory containing multilog files\n");
        exit(-1);
    }
    strncpy(TheDir, argv[1], MAX_BUFF);

    end_time = time(NULL);
    start_time = end_time - 300; 
    max_files = 0;


    mydir = opendir(TheDir);
    if ( mydir == NULL ) {
        printf("failed to open dir %s\n", TheDir);
        exit(-1);
    }

    while((mydirent=readdir(mydir))!=NULL) {
        if ( mydirent->d_name[0]=='@' ) {
            secs = get_tai(&mydirent->d_name[1]);
            if ( secs > start_time ) { 
                strncpy(TheFile, TheDir, MAX_BUFF);
                strncat(TheFile, "/", MAX_BUFF);
                strncat(TheFile, mydirent->d_name, MAX_BUFF);
                process_file(TheFile);
            }
        } else if ( strcmp(mydirent->d_name, "current") == 0 ) {
            strncpy(TheFile, TheDir, MAX_BUFF);
            strncat(TheFile, "/", MAX_BUFF);
            strncat(TheFile, mydirent->d_name, MAX_BUFF);
            process_file(TheFile);
        }
    }
    closedir(mydir);
    return(0);
}

void process_file( char *file_name)
{
 FILE *fs;
 MYSQL *mysql = NULL;
 unsigned long secs;
 char *tmpstr1;
 char tmpstr2[MAX_BUFF];
 char tmpstr3[MAX_BUFF];
 char Query[MAX_BUFF];
 char *p;
 char *q;
 int result;

    if ( (fs=fopen(file_name,"r"))==NULL) return;

    mysql = mysql_init(NULL);
    if (mysql) {
   	if (mysql_real_connect(mysql,MYSQLHOST,MYSQLUSER,MYSQLPASS,MYSQLDB,0,NULL,0)) {
    	  while(fgets(TmpBuf,MAX_BUFF,fs)!=NULL){
            if ( TmpBuf[0] != '@' ) continue;
            secs = get_tai(&TmpBuf[1]);
            if ( secs < start_time || secs > end_time ) continue;

            if ((tmpstr1 = strstr(TmpBuf, ":VIRUS:"))!=NULL) {
		sprintf(tmpstr3,"%lu",secs);
		strcpy(Query,"INSERT into virus (id,ts,virus,ip,sender,receiver) values(0,");
		strcat(Query,tmpstr3);
		strcat(Query,",'");
		
		p = &tmpstr1[7];
       		q = strchr(p, ':');
		while(q != NULL) {
        		sprintf(tmpstr2,"%.*s", q - p, p);
			strcat(Query,tmpstr2);
			strcat(Query,"','");
        		p = q + 1;
        		q = strchr(p, ':');
		}
		sprintf(tmpstr2,"%s",p);
		strncat(Query,tmpstr2,strlen(tmpstr2)-1);
		strcat(Query,"')");
		result = mysql_query(mysql,Query);
/*		printf ("%s\n",Query); */
            }
         }
       }
    }
    if(mysql) mysql_close(mysql);
    fclose(fs);
}
    
unsigned long get_tai( char *tmpstr)
{
 unsigned long secs;
 unsigned long nanosecs;
 unsigned long u;

    secs = 0;
        nanosecs = 0;

    for(;*tmpstr!=0;++tmpstr){
        u = *tmpstr - '0';
        if (u >= 10) {
            u = *tmpstr - 'a';
                  if (u >= 6) break;
                  u += 10;
            }
            secs <<= 4;
            secs += nanosecs >> 28;
            nanosecs &= 0xfffffff;
            nanosecs <<= 4;
            nanosecs += u;
    }
    return(secs);
}


int get_size(diri)
 char *diri;
{
 int i;
 int count = 0;
 char tmpbuf[200];

    for(i=0,count=0;i<ConfSplit;++i) {
	sprintf(tmpbuf,"%s/%d", diri, i); 
        count += count_files(tmpbuf);
    }
    return(count);
}

int count_files(char *diri)
{
 DIR *mydir;
 int count;
 struct dirent *mydirent;

	mydir = opendir(diri);
	if ( mydir == NULL ) return(0);
	for(count=0; (mydirent=readdir(mydir))!=NULL;){
		if ( strcmp(mydirent->d_name,".")!=0 &&
                     strcmp(mydirent->d_name,"..")!=0 ) {
                    ++count;
                }
        }
	closedir(mydir);
	return(count);
}
